#ifndef _BL_H_
#define _BL_H_

#include <stdbool.h>
#include <stdint.h>
#include "commsPacket.h"


#define BL_CAP_FLAGS_FTR_OUT_SUPPORTED					0x01
#define BL_CAP_FLAGS_NEED_PADDING						0x02
#define BL_CAP_FLAGS_CDC_SUPPORTED						0x04
#define BL_CAP_BL_VERSION_REPORTING						0x08

#define packet_sz_t uint8_t

#define PACKET_RX_FAIL			((packet_sz_t)-1LL)

bool packetCanSend(void);
void packetSend(const struct CommsPacket *pkt, packet_sz_t payloadLen);
packet_sz_t packetRx(struct CommsPacket **dst);
void packetRxRelease(void);
void usbWork(void);
void bootloader(bool withTimeout);
void getUsbCaps(packet_sz_t *maxPacketSzP, uint8_t *flagsP);	//BL_CAP_FLAGS_*
void usbReenumerate(const void *newDeviceStrDescr, const void *newSnumStrDescr);
uint8_t blGetBlVersion(void);		//only if BL_CAP_BL_VERSION_REPORTING

#endif
